// 24bitPointerGrabber v1.0
// Coded by DaMarsMan 2006
// Kojiro Translations
#define false 0
#define true 1
#include <fstream>
#include <iomanip>
#include <iostream>
#include <stdio.h>
#include <tchar.h>
#include <malloc.h>

#define null '\0'
#ifndef dwrd
 typedef unsigned char  byte;
 typedef unsigned short word;
 typedef unsigned long  dwrd;
#endif


using namespace std;

//Global Variable Declarations
ifstream RomFile;
ofstream OutFile;
dwrd TextStart;
dwrd TextEnd;
byte RomBuffer[0xFFFFFF];
dwrd RomFileSize;
dwrd DoReverse;
char* RomFileName;
char* OutputFileName;
char* RomType;
byte EndString;

// Prototypes
int HexString2Integer(const TCHAR *value);
dwrd PC2LoRom00(dwrd pc);
dwrd PC2LoRom80(dwrd pc);
dwrd PC2HiRomC0(dwrd pc);
dwrd ReverseBytes(dwrd pointer);
void SearchRom();
void SearchForPointer(dwrd pointer);

void main(int argc, char *argv[]) 
{
	if (argc!=8)
	{
		printf("PointerGrabber v1.0....\nUsage: PointerGrabber <Rom.ext> <Pointers.ext> <TextStart> <TextEnd> <EndChar> <RomType> <Reverse>\n\n<Rom Type> can be LoRom00, LoRom80, HiRomC0, or PC.\n<Reverse> is 0 for no and 1 for yes.\nAll offsets should be in hex format without 0x!\n\n");
	}
	else
	{
	RomFileName = argv[1];
	OutputFileName = argv[2];
	TextStart = HexString2Integer(argv[3]);	//convert hex string to int
	TextEnd = HexString2Integer(argv[4]);
	EndString = HexString2Integer(argv[5]);
	RomType = strupr(argv[6]);
	DoReverse = HexString2Integer(argv[7]);
	SearchRom();
	cout<<"Pointers found saved to "<<OutputFileName<<endl;
	}
}

dwrd PC2LoRom00(dwrd pc)
{
	dwrd lorom;
	if ((pc & 0x0000FFFF) < 0x8000)
	{
	lorom = (pc & 0x0000FFFF) + ((pc/0x8000)<<16) ;
	lorom += 0x8000;
	}
	else 
	{
	lorom = (pc & 0x0000FFFF) + ((pc/0x8000)<<16);
	}
	return lorom;
}

dwrd PC2LoRom80(dwrd pc)
{
	dwrd lorom;
	if ((pc & 0x0000FFFF) < 0x8000)
	{
	lorom = (pc & 0x0000FFFF) + ((pc/0x8000)<<16) ;
	lorom += 0x8000;
	}
	else 
	{
	lorom = (pc & 0x0000FFFF) + ((pc/0x8000)<<16);
	}
	return lorom+0x800000;
}


dwrd PC2HiRomC0(dwrd pc)
{	
	return pc+0xC00000;
}

dwrd ReverseBytes(dwrd pointer)
{
dwrd reversed;
reversed = ((pointer&0xFF)<<16) + (pointer&0xFF00) + ((pointer&0xFF0000)>>16);
return reversed;
}

int HexString2Integer(const TCHAR *value)
{
  struct CHexMap
  {
    TCHAR chr;
    int value;
  };
  const int HexMapL = 16;
  CHexMap HexMap[HexMapL] =
  {
    {'0', 0}, {'1', 1},
    {'2', 2}, {'3', 3},
    {'4', 4}, {'5', 5},
    {'6', 6}, {'7', 7},
    {'8', 8}, {'9', 9},
    {'A', 10}, {'B', 11},
    {'C', 12}, {'D', 13},
    {'E', 14}, {'F', 15}
  };
  TCHAR *mstr = _tcsupr(_tcsdup(value));
  TCHAR *s = mstr;
  int result = 0;
  if (*s == '0' && *(s + 1) == 'X') s += 2;
  bool firsttime = true;
  while (*s != '\0')
  {
    bool found = false;
    for (int i = 0; i < HexMapL; i++)
    {
      if (*s == HexMap[i].chr)
      {
        if (!firsttime) result <<= 4;
        result |= HexMap[i].value;
        found = true;
        break;
      }
    }
    if (!found) break;
    s++;
    firsttime = false;
  }
  free(mstr);
  return result;
}

void SearchRom()
{
char* OffsetsFound = "";
dwrd Pointer;
dwrd Position;
RomFile.open(RomFileName, ios::in | ios::binary);
if (!RomFile.is_open()) {cout<<"RomFile not found in this directory.\n";return;}
RomFile.seekg(0, ios::end);
RomFileSize = RomFile.tellg();
RomFile.seekg(0, ios::beg);
RomFile.read((char*)RomBuffer,RomFileSize);
RomFile.close();

OutFile.open(OutputFileName, ios::out);

Position = TextStart;
cout<<"Jumping to "<<hex<<Position<<endl;

Pointer = Position;
if (strcmp(RomType,"LOROM00")==0) {Pointer = PC2LoRom00(Pointer);}
else if (strcmp(RomType,"LOROM80")==0) {Pointer = PC2LoRom80(Pointer);}
else if (strcmp(RomType,"HIROMC0")==0) {Pointer = PC2HiRomC0(Pointer);}
else if (strcmp(RomType,"PC")==0) {}
else {cout<<"ERROR: <Rom Type> can only be LoRom00, LoRom80, HiRomC0, or PC! \nProgram exiting...";return;}
if (DoReverse==1) {Pointer = ReverseBytes(Pointer);}
SearchForPointer(Pointer);
OutFile<<endl;

	while (Position<=TextEnd)
	{
		if (RomBuffer[Position]==EndString)
		{
			cout<<"End String found at "<<hex<<Position<<endl;
			Pointer = Position;
			Pointer += 1;
			if (strcmp(RomType,"LOROM00")==0) {Pointer = PC2LoRom00(Pointer);}
			else if (strcmp(RomType,"LOROM80")==0) {Pointer = PC2LoRom80(Pointer);}
			else if (strcmp(RomType,"HIROMC0")==0) {Pointer = PC2HiRomC0(Pointer);}
			else if (strcmp(RomType,"PC")==0) {}
			else {cout<<"ERROR: <Rom Type> can only be LoRom00, LoRom80, HiRomC0, or PC! \nProgram exiting...";return;}
			if (DoReverse==1) {Pointer = ReverseBytes(Pointer);}
			SearchForPointer(Pointer);
			OutFile<<endl;
		};
		Position++;
	}

	OutFile.close();
	return;
}

void SearchForPointer(dwrd pointer)
{
	dwrd PointerTest=0;
	word foundcount=0;
	for (int x=0;x<=RomFileSize;x++)
	{
		PointerTest = (RomBuffer[x]<<16) + (RomBuffer[x+1]<<8) + (RomBuffer[x+2]);
		//cout<<hex<<PointerTest;
		if (PointerTest == pointer) 
		{
			if (foundcount>0) OutFile<<", "<<hex<<x;
			else OutFile<<hex<<x;
			foundcount++;
		}
	}

}